#ifndef SVN_FS_NODE_HH
#define SVN_FS_NODE_HH

#include <svn/fs/filesystem.hh>

typedef struct svn_fs_id_t svn_fs_id_t;

namespace svn {
namespace fs {

/**
 * A node, which corresponds roughly to an 'inode' in a Unix filesystem:
 * <ul>
 * <li>A node is either a file or a directory.</li>
 * <li>A node's contents change over time.</li>
 * <li>When you change a node's contents, it's still the same node; it's
 *     just been changed. So a node's identity isn't bound to a specific
 *     set of contents.</li>
 * <li>If you rename a node, it's still the same node, just under a different
 *     name. So a node's identity isn't bound to a particular filename.</li>
 * </ul>
 **/
class Node {
    private:
        svn_fs_id_t *me;
};

}
}

#endif //!SVN_FS_NODE_HH
