#ifndef SVN_REVISION_HH
#define SVN_REVISION_HH

#include <svn_types.h>
#include <string>

namespace svn {

class RevisionNumber {
    public:
        RevisionNumber(svn_revnum_t v = SVN_INVALID_REVNUM) : me(v) {}

        inline RevisionNumber(const std::string &revstring) {
            me = SVN_STR_TO_REV(revstring.c_str());
        }

        inline bool isValid() const { return SVN_IS_VALID_REVNUM(me); }
        inline operator svn_revnum_t() const { return me; }

        inline const RevisionNumber& operator=(svn_revnum_t o) {
            me = o;
            return *this;
        }

    private:
        svn_revnum_t me;
};

enum NodeKind {
    nNone,      ///< Absent
    nFile,      ///< Regular file
    nDir,       ///< Directory
    nUnknown    ///< Something's here, but we don't know what.
};

}

#endif
