#include <string>
#include <exception>
#include <iostream>
#include <apr_general.h>
#include <svn/pool.hh>
#include <svn/types.hh>
#include <svn/ra/callbacks.hh>
#include <svn/ra/library.hh>
#include <svn/ra/session.hh>
#include <svn/client.hh>

using namespace std;
using namespace svn;

const string MYREPO = "https://www.slamb.org/svn/repos";

void notify(const wc::Notification&) {}

int main() {
    apr_status_t apr_err = apr_initialize();
    if (apr_err) {
        cerr << "Error: apr_initialize" << endl;
        return EXIT_FAILURE;
    }
    int err2 = atexit(apr_terminate);
    if (err2) {
        cerr << "Error: atexit returned " << err2 << endl;
        return EXIT_FAILURE;
    }

    try {

        Pool top;

        /* RA stuff
        ra::Callbacks callbacks;
        ra::Libraries libs(top);
        ra::Library lib(libs, MYREPO, top);
        cout << "RA library is " << lib.getName() << endl
             << "\t" << lib.getDescription() << endl;
        ra::Session session(lib, MYREPO, callbacks, top);
        cout << "Repository " << MYREPO << endl;
        cout << "Latest revision is " << session.getLatestRevision() << endl;
         */

        /* Client stuff */
        client::AuthBaton authBaton;
        authBaton.setStoreAuthInfo(true);
        //client::checkout(notify, authBaton, MYREPO + "/projects/primes",
        //        "/tmp/primes", client::RevisionSpecifier::HEAD, true, top);
        client::update(authBaton, "/tmp/primes",
                client::RevisionSpecifier::HEAD, true, notify, top);

    } catch (exception &e) {
        cerr << "Error: " << e.what() << endl;
        return EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}
